// D import file generated from 'derelict/assimp3/types.d'
module derelict.assimp3.types;
struct aiVectorKey
{
	double mTime;
	aiVector3D mValue;
}
struct aiQuatKey
{
	double mTime;
	aiQuaternion mValue;
}
struct aiMeshKey
{
	double mTime;
	uint mValue;
}
alias aiAnimBehaviour = uint;
enum : uint
{
	aiAnimBehaviour_DEFAULT = 0,
	aiAnimBehaviour_CONSTANT = 1,
	aiAnimBehaviour_LINEAR = 2,
	aiAnimBehaviour_REPEAT = 3,
}
struct aiNodeAnim
{
	aiString mNodeName;
	uint mNumPositionKeys;
	aiVectorKey* mPositionKeys;
	uint mNumRotationKeys;
	aiQuatKey* mRotationKeys;
	uint mNumScalingKeys;
	aiVectorKey* mScalingKeys;
	aiAnimBehaviour mPreState;
	aiAnimBehaviour mPostState;
}
struct aiMeshAnim
{
	aiString mName;
	uint mNumKeys;
	aiMeshKey* mKeys;
}
struct aiAnimation
{
	aiString mName;
	double mDuration;
	double mTicksPerSecond;
	uint mNumChannels;
	aiNodeAnim** mChannels;
	uint mNumMeshChannels;
	aiMeshAnim** mMeshChannels;
}
struct aiCamera
{
	aiString mName;
	aiVector3D mPosition;
	aiVector3D mUp;
	aiVector3D mLookAt;
	float mHorizontalFOV;
	float mClipPlaneNear;
	float mClipPlaneFar;
	float mAspect;
}
struct aiExportFormatDesc
{
	const(char)* id;
	const(char)* description;
	const(char)* fileExtension;
}
struct aiExportDataBlob
{
	size_t size;
	void* data;
	aiString name;
	aiExportDataBlob* next;
}
extern (C) nothrow 
{
	alias aiFileWriteProc = size_t function(aiFile*, const(char)*, size_t, size_t);
	alias aiFileReadProc = size_t function(aiFile*, char*, size_t, size_t);
	alias aiFileTellProc = size_t function(aiFile*);
	alias aiFileFlushProc = void function(aiFile*);
	alias aiFileSeek = aiReturn function(aiFile*, size_t, aiOrigin);
	alias aiFileOpenProc = aiFile* function(aiFileIO*, const(char)*, const(char)*);
	alias aiFileCloseProc = void function(aiFileIO*, aiFile*);
}
alias aiUserData = void*;
struct aiFileIO
{
	aiFileOpenProc OpenProc;
	aiFileCloseProc CloseProc;
	aiUserData UserData;
}
struct aiFile
{
	aiFileReadProc ReadProc;
	aiFileWriteProc WriteProc;
	aiFileTellProc TellProc;
	aiFileTellProc FileSizeProc;
	aiFileSeek SeekProc;
	aiFileFlushProc FlushProc;
	aiUserData UserData;
}
extern (C) nothrow alias aiLogStreamCallback = void function(const(char)*, char*);
struct aiLogStream
{
	aiLogStreamCallback callback;
	char* user;
}
struct aiPropertyStore
{
	char sentinel;
}
alias aiBool = int;
enum AI_FALSE = 0;
enum AI_TRUE = 1;
align (1) struct aiColor4D
{
	float r;
	float g;
	float b;
	float a;
}
enum : string
{
	AI_CONFIG_GLOB_MEASURE_TIME = "GLOB_MEASURE_TIME",
	AI_CONFIG_PP_SBBC_MAX_BONES = "PP_SBBC_MAX_BONES",
	AI_CONFIG_PP_CT_MAX_SMOOTHING_ANGLE = "PP_CT_MAX_SMOOTHING_ANGLE",
	AI_CONFIG_PP_CT_TEXTURE_CHANNEL_INDEX = "PP_CT_TEXTURE_CHANNEL_INDEX",
	AI_CONFIG_PP_GSN_MAX_SMOOTHING_ANGLE = "PP_GSN_MAX_SMOOTHING_ANGLE",
	AI_CONFIG_IMPORT_MDL_COLORMAP = "IMPORT_MDL_COLORMAP",
	AI_CONFIG_PP_RRM_EXCLUDE_LIST = "PP_RRM_EXCLUDE_LIST",
	AI_CONFIG_PP_PTV_KEEP_HIERARCHY = "PP_PTV_KEEP_HIERARCHY",
	AI_CONFIG_PP_PTV_NORMALIZE = "PP_PTV_NORMALIZE",
	AI_CONFIG_PP_FD_REMOVE = "PP_FD_REMOVE",
	AI_CONFIG_PP_OG_EXCLUDE_LIST = "PP_OG_EXCLUDE_LIST",
	AI_CONFIG_PP_SLM_TRIANGLE_LIMIT = "PP_SLM_TRIANGLE_LIMIT",
	AI_CONFIG_PP_SLM_VERTEX_LIMIT = "PP_SLM_VERTEX_LIMIT",
	AI_CONFIG_PP_LBW_MAX_WEIGHTS = "PP_LBW_MAX_WEIGHTS",
	AI_CONFIG_PP_DB_THRESHOLD = "PP_DB_THRESHOLD",
	AI_CONFIG_PP_DB_ALL_OR_NONE = "PP_DB_ALL_OR_NONE",
	AI_CONFIG_PP_ICL_PTCACHE_SIZE = "PP_ICL_PTCACHE_SIZE",
	AI_CONFIG_PP_RVC_FLAGS = "PP_RVC_FLAGS",
	AI_CONFIG_PP_SBP_REMOVE = "PP_SBP_REMOVE",
	AI_CONFIG_PP_FID_ANIM_ACCURACY = "PP_FID_ANIM_ACCURACY",
	AI_CONFIG_PP_TUV_EVALUATE = "PP_TUV_EVALUATE",
	AI_CONFIG_FAVOUR_SPEED = "FAVOUR_SPEED",
	AI_CONFIG_IMPORT_GLOBAL_KEYFRAME = "IMPORT_GLOBAL_KEYFRAME",
	AI_CONFIG_IMPORT_MD3_KEYFRAME = "IMPORT_MD3_KEYFRAME",
	AI_CONFIG_IMPORT_MD2_KEYFRAME = "IMPORT_MD2_KEYFRAME",
	AI_CONFIG_IMPORT_MDL_KEYFRAME = "IMPORT_MDL_KEYFRAME",
	AI_CONFIG_IMPORT_MDC_KEYFRAME = "IMPORT_MDC_KEYFRAME",
	AI_CONFIG_IMPORT_SMD_KEYFRAME = "IMPORT_SMD_KEYFRAME",
	AI_CONFIG_IMPORT_UNREAL_KEYFRAME = "AI_CONFIG_IMPORT_UNREAL_KEYFRAME",
	AI_CONFIG_IMPORT_AC_SEPARATE_BFCULL = "IMPORT_AC_SEPARATE_BFCULL",
	AI_CONFIG_IMPORT_AC_EVAL_SUBDIVISION = "IMPORT_AC_EVAL_SUBDIVISION",
	AI_CONFIG_IMPORT_UNREAL_HANDLE_FLAGS = "UNREAL_HANDLE_FLAGS",
	AI_CONFIG_IMPORT_TER_MAKE_UVS = "IMPORT_TER_MAKE_UVS",
	AI_CONFIG_IMPORT_ASE_RECONSTRUCT_NORMALS = "IMPORT_ASE_RECONSTRUCT_NORMALS",
	AI_CONFIG_IMPORT_MD3_HANDLE_MULTIPART = "IMPORT_MD3_HANDLE_MULTIPART",
	AI_CONFIG_IMPORT_MD3_SKIN_NAME = "IMPORT_MD3_SKIN_NAME",
	AI_CONFIG_IMPORT_MD3_SHADER_SRC = "IMPORT_MD3_SHADER_SRC",
	AI_CONFIG_IMPORT_LWO_ONE_LAYER_ONLY = "IMPORT_LWO_ONE_LAYER_ONLY",
	AI_CONFIG_IMPORT_MD5_NO_ANIM_AUTOLOAD = "IMPORT_MD5_NO_ANIM_AUTOLOAD",
	AI_CONFIG_IMPORT_LWS_ANIM_START = "IMPORT_LWS_ANIM_START",
	AI_CONFIG_IMPORT_LWS_ANIM_END = "IMPORT_LWS_ANIM_END",
	AI_CONFIG_IMPORT_IRR_ANIM_FPS = "IMPORT_IRR_ANIM_FPS",
	AI_CONFIG_IMPORT_OGRE_MATERIAL_FILE = "IMPORT_OGRE_MATERIAL_FILE",
	AI_CONFIG_IMPORT_OGRE_TEXTURETYPE_FROM_FILENAME = "IMPORT_OGRE_TEXTURETYPE_FROM_FILENAME",
	AI_CONFIG_IMPORT_IFC_SKIP_SPACE_REPRESENTATIONS = "IMPORT_IFC_SKIP_SPACE_REPRESENTATIONS",
	AI_CONFIG_IMPORT_IFC_SKIP_CURVE_REPRESENTATIONS = "IMPORT_IFC_SKIP_CURVE_REPRESENTATIONS",
	AI_CONFIG_IMPORT_IFC_CUSTOM_TRIANGULATION = "IMPORT_IFC_CUSTOM_TRIANGULATION",
}
enum AI_SBBC_DEFAULT_MAX_BONES = 60;
enum AI_SLM_DEFAULT_MAX_TRIANGLES = 1000000;
enum AI_SLM_DEFAULT_MAX_VERTICES = 1000000;
enum AI_LMW_MAX_WEIGHTS = 4;
enum AI_DEBONE_THRESHOLD = 1.00000F;
enum PP_ICL_PTCACHE_SIZE = 12;
enum 
{
	AI_UVTRAFO_SCALING = 1,
	AI_UVTRAFO_ROTATION = 2,
	AI_UVTRAFO_TRANSLATION = 4,
	AI_UVTRAFO_ALL = AI_UVTRAFO_SCALING | AI_UVTRAFO_ROTATION | AI_UVTRAFO_TRANSLATION,
}
alias aiComponent = uint;
enum : uint
{
	aiComponent_NORMALS = 2,
	aiComponent_TANGENTS_AND_BITANGENTS = 4,
	aiComponent_COLORS = 8,
	aiComponent_TEXCOORDS = 16,
	aiComponent_BONEWEIGHTS = 32,
	aiComponent_ANIMATIONS = 64,
	aiComponent_TEXTURES = 128,
	aiComponent_LIGHTS = 256,
	aiComponent_CAMERAS = 512,
	aiComponent_MESHES = 1024,
	aiComponent_MATERIALS = 2048,
}
uint aiComponent_COLORSn(uint n);
uint aiComponent_TEXCOORDSn(uint n);
alias aiLightSourceType = uint;
enum : uint
{
	aiLightSourceType_UNDEFINED = 0,
	aiLightSourceType_DIRECTIONAL = 1,
	aiLightSourceType_POINT = 2,
	aiLightSourceType_SPOT = 3,
}
struct aiLight
{
	aiString mName;
	aiLightSourceType mType;
	aiVector3D mPosition;
	aiVector3D mDirection;
	float mAttenuationConstant;
	float mAttenuationLinear;
	float mAttenuationQuadratic;
	aiColor3D mColorDiffuse;
	aiColor3D mColorSpecular;
	aiColor3D mColorAmbient;
	float mAngleOuterCone;
}
enum AI_DEFAULT_MATERIAL_NAME = "DefaultMaterial";
alias aiTextureOp = uint;
enum : uint
{
	aiTextureOp_Multiply = 0,
	aiTextureOp_Add = 1,
	aiTextureOp_Subtract = 2,
	aiTextureOp_Divide = 3,
	aiTextureOp_SmoothAdd = 4,
	aiTextureOp_SignedAdd = 5,
}
alias aiTextureMapMode = uint;
enum : uint
{
	aiTextureMapMode_Wrap = 0,
	aiTextureMapMode_Clamp = 1,
	aiTextureMapMode_Decal = 3,
	aiTextureMapMode_Mirror = 2,
}
alias aiTextureMapping = uint;
enum : uint
{
	aiTextureMapping_UV = 0,
	aiTextureMapping_SPHERE = 1,
	aiTextureMapping_CYLINDER = 2,
	aiTextureMapping_BOX = 3,
	aiTextureMapping_PLANE = 4,
	aiTextureMapping_OTHER = 5,
}
alias aiTextureType = uint;
enum : uint
{
	aiTextureType_NONE = 0,
	aiTextureType_DIFFUSE = 1,
	aiTextureType_SPECULAR = 2,
	aiTextureType_AMBIENT = 3,
	aiTextureType_EMISSIVE = 4,
	aiTextureType_HEIGHT = 5,
	aiTextureType_NORMALS = 6,
	aiTextureType_SHININESS = 7,
	aiTextureType_OPACITY = 8,
	aiTextureType_DISPLACEMENT = 9,
	aiTextureType_LIGHTMAP = 10,
	aiTextureType_REFLECTION = 11,
	aiTextureType_UNKNOWN = 12,
}
alias aiShadingMode = uint;
enum : uint
{
	aiShadingMode_Flat = 1,
	aiShadingMode_Gouraud = 2,
	aiShadingMode_Phong = 3,
	aiShadingMode_Blinn = 4,
	aiShadingMode_Toon = 5,
	aiShadingMode_OrenNayer = 6,
	aiShadingMode_Minnaert = 7,
	aiShadingMode_CookTorrance = 8,
	aiShadingMode_NoShading = 9,
	aiShadingMode_Fresnel = 10,
}
alias aiTextureFlags = uint;
enum : uint
{
	aiTextureFlags_Invert = 1,
	aiTextureFlags_UseAlpha = 2,
	aiTextureFlags_IgnoreAlpha = 4,
}
alias aiBlendMode = uint;
enum : uint
{
	aiBlendMode_Default = 0,
	aiBlendMode_Additive = 1,
}
align (1) struct aiUVTransform
{
	aiVector2D mTranslation;
	aiVector2D mScaling;
}
alias aiPropertyTypeInfo = uint;
enum : uint
{
	aiPTI_Float = 1,
	aiPTI_String = 3,
	aiPTI_Integer = 4,
	aiPTI_Buffer = 5,
}
struct aiMaterialProperty
{
	aiString mKey;
	uint mSemantic;
	uint mIndex;
	uint mDataLength;
	aiPropertyTypeInfo mType;
	byte* mData;
}
struct aiMaterial
{
	aiMaterialProperty** mProperties;
	uint mNumProperties;
	uint mNumAllocated;
}
enum 
{
	AI_MATKEY_NAME = "?mat.name",
	AI_MATKEY_TWOSIDED = "$mat.twosided",
	AI_MATKEY_SHADING_MODEL = "$mat.shadingm",
	AI_MATKEY_ENABLE_WIREFRAM = "$mat.wireframe",
	AI_MATKEY_BLEND_FUNC = "$mat.blend",
	AI_MATKEY_OPACITY = "$mat.opacity",
	AI_MATKEY_BUMPSCALING = "$mat.bumpscaling",
	AI_MATKEY_SHININESS = "$mat.shininess",
	AI_MATKEY_REFLECTIVITY = "$mat.reflectivity",
	AI_MATKEY_SHININESS_STRENGTH = "$mat.shinpercent",
	AI_MATKEY_REFRACTI = "$mat.refracti",
	AI_MATKEY_COLOR_DIFFUSE = "$clr.diffuse",
	AI_MATKEY_COLOR_AMBIENT = "$clr.ambient",
	AI_MATKEY_COLOR_SPECULAR = "$clr.specular",
	AI_MATKEY_COLOR_EMISSIVE = "$clr.emissive",
	AI_MATKEY_COLOR_TRANSPARENT = "$clr.transparent",
	AI_MATKEY_COLOR_REFLECTIVE = "$clr.reflective",
	AI_MATKEY_GLOBAL_BACKGROUND_IMAGE = "?bg.global",
	AI_MATKEY_TEXTURE = "$tex.file",
	AI_MATKEY_UVWSRC = "$tex.uvwsrc",
	AI_MATKEY_TEXOP = "$tex.op",
	AI_MATKEY_MAPPING = "$tex.mapping",
	AI_MATKEY_TEXBLEND = "$tex.blend",
	AI_MATKEY_MAPPINGMODE_U = "$tex.mapmodeu",
	AI_MATKEY_MAPPINGMODE_V = "$tex.mapmodev",
	AI_MATKEY_TEXMAP_AXIS = "$tex.mapaxis",
	AI_MATKEY_UVTRANSFORM = "$tex.uvtrafo",
	AI_MATKEY_TEXFLAGS = "$tex.flags",
}
align (1) struct aiMatrix3x3
{
	float a1;
	float a2;
	float a3;
	float b1;
	float b2;
	float b3;
	float c1;
	float c2;
	float c3;
}
struct aiMatrix4x4
{
	float a1;
	float a2;
	float a3;
	float a4;
	float b1;
	float b2;
	float b3;
	float b4;
	float c1;
	float c2;
	float c3;
	float c4;
	float d1;
	float d2;
	float d3;
	float d4;
}
enum AI_MAX_FACE_INDICES = 32767;
enum AI_MAX_BONE_WEIGHTS = 2147483647;
enum AI_MAX_VERTICES = 2147483647;
enum AI_MAX_FACES = 2147483647;
enum AI_MAX_NUMBER_OF_COLOR_SETS = 8;
enum AI_MAX_NUMBER_OF_TEXTURECOORDS = 8;
struct aiFace
{
	uint mNumIndices;
	uint* mIndices;
}
struct aiVertexWeight
{
	uint mVertexId;
	float mWeight;
}
struct aiBone
{
	aiString mName;
	uint mNumWeights;
	aiVertexWeight* mWeights;
	aiMatrix4x4 mOffsetMatrix;
}
alias aiPrimitiveType = uint;
enum : uint
{
	aiPrimitiveType_POINT = 1,
	aiPrimitiveType_LINE = 2,
	aiPrimitiveType_TRIANGLE = 4,
	aiPrimitiveType_POLYGON = 8,
}
struct aiAnimMesh
{
	aiVector3D* mVertices;
	aiVector3D* mNormals;
	aiVector3D* mTangents;
	aiVector3D* mBitangents;
	aiColor4D*[AI_MAX_NUMBER_OF_COLOR_SETS] mColors;
	aiVector3D*[AI_MAX_NUMBER_OF_TEXTURECOORDS] mTextureCoords;
	uint mNumVertices;
}
struct aiMesh
{
	uint mPrimitiveTypes;
	uint mNumVertices;
	uint mNumFaces;
	aiVector3D* mVertices;
	aiVector3D* mNormals;
	aiVector3D* mTangents;
	aiVector3D* mBitangents;
	aiColor4D*[AI_MAX_NUMBER_OF_COLOR_SETS] mColors;
	aiVector3D*[AI_MAX_NUMBER_OF_TEXTURECOORDS] mTextureCoords;
	uint[AI_MAX_NUMBER_OF_TEXTURECOORDS] mNumUVComponents;
	aiFace* mFaces;
	uint mNumBones;
	aiBone** mBones;
	uint mMaterialIndex;
	aiString mName;
	uint mNumAnimMeshes;
	aiAnimMesh** mAnimMeshes;
}
alias aiPostProcessSteps = uint;
enum : uint
{
	aiProcess_CalcTangentSpace = 1,
	aiProcess_JoinIdenticalVertices = 2,
	aiProcess_MakeLeftHanded = 4,
	aiProcess_Triangulate = 8,
	aiProcess_RemoveComponent = 16,
	aiProcess_GenNormals = 32,
	aiProcess_GenSmoothNormals = 64,
	aiProcess_SplitLargeMeshes = 128,
	aiProcess_PreTransformVertices = 256,
	aiProcess_LimitBoneWeights = 512,
	aiProcess_ValidateDataStructure = 1024,
	aiProcess_ImproveCacheLocality = 2048,
	aiProcess_RemoveRedundantMaterials = 4096,
	aiProcess_FixInFacingNormals = 8192,
	aiProcess_SortByPType = 32768,
	aiProcess_FindDegenerates = 65536,
	aiProcess_FindInvalidData = 131072,
	aiProcess_GenUVCoords = 262144,
	aiProcess_TransformUVCoords = 524288,
	aiProcess_FindInstances = 1048576,
	aiProcess_OptimizeMeshes = 2097152,
	aiProcess_OptimizeGraph = 4194304,
	aiProcess_FlipUVs = 8388608,
	aiProcess_FlipWindingOrder = 16777216,
	aiProcess_SplitByBoneCount = 33554432,
	aiProcess_Debone = 67108864,
	aiProcess_ConvertToLeftHanded = aiProcess_MakeLeftHanded | aiProcess_FlipUVs | aiProcess_FlipWindingOrder | 0,
	aiProcessPreset_TargetRealtime_Fast = aiProcess_CalcTangentSpace | aiProcess_GenNormals | aiProcess_JoinIdenticalVertices | aiProcess_Triangulate | aiProcess_GenUVCoords | aiProcess_SortByPType | 0,
	aiProcessPreset_TargetRealtime_Quality = aiProcess_CalcTangentSpace | aiProcess_GenSmoothNormals | aiProcess_JoinIdenticalVertices | aiProcess_ImproveCacheLocality | aiProcess_LimitBoneWeights | aiProcess_RemoveRedundantMaterials | aiProcess_SplitLargeMeshes | aiProcess_Triangulate | aiProcess_GenUVCoords | aiProcess_SortByPType | aiProcess_FindDegenerates | aiProcess_FindInvalidData | 0,
	aiProcessPreset_TargetRealtime_MaxQuality = aiProcessPreset_TargetRealtime_Quality | aiProcess_FindInstances | aiProcess_ValidateDataStructure | aiProcess_OptimizeMeshes | aiProcess_Debone | 0,
}
struct aiQuaternion
{
	float w;
	float x;
	float y;
	float z;
}
struct aiVector2D
{
	float x;
	float y;
}
align (1) struct aiVector3D
{
	float x;
	float y;
	float z;
}
struct aiNode
{
	aiString mName;
	aiMatrix4x4 mTransformation;
	aiNode* mParent;
	uint mNumChildren;
	aiNode** mChildren;
	uint mNumMeshes;
	uint* mMeshes;
}
enum 
{
	AI_SCENE_FLAGS_INCOMPLETE = 1,
	AI_SCENE_FLAGS_VALIDATED = 2,
	AI_SCENE_FLAGS_VALIDATION_WARNING = 4,
	AI_SCENE_FLAGS_NON_VERBOSE_FORMAT = 8,
	AI_SCENE_FLAGS_TERRAIN = 16,
}
struct aiScene
{
	uint mFlags;
	aiNode* mRootNode;
	uint mNumMeshes;
	aiMesh** mMeshes;
	uint mNumMaterials;
	aiMaterial** mMaterials;
	uint mNumAnimations;
	aiAnimation** mAnimations;
	uint mNumTextures;
	aiTexture** mTexture;
	uint mNumLights;
	aiLight** mLights;
	uint mNumCameras;
	aiCamera** mCameras;
}
align (1) struct aiTexel
{
	ubyte b;
	ubyte g;
	ubyte r;
	ubyte a;
}
struct aiTexture
{
	uint mWidth;
	uint mHeight;
	char[4] achFormatHint;
	aiTexel* pcData;
}
enum MAXLEN = 1024;
align (1) struct aiPlane
{
	float a;
	float b;
	float c;
	float d;
}
align (1) struct aiRay
{
	aiVector3D pos;
	aiVector3D dir;
}
align (1) struct aiColor3D
{
	float r;
	float g;
	float b;
}
struct aiString
{
	size_t length;
	char[MAXLEN] data;
}
alias aiReturn = int;
enum 
{
	aiReturn_SUCCESS = 0,
	aiReturn_FAILURE = -1,
	aiReturn_OUTOFMEMORY = -3,
}
alias aiOrigin = uint;
enum : uint
{
	aiOrigin_SET = 0,
	aiOrigin_CUR = 1,
	aiOrigin_END = 2,
}
alias aiDefaultLogStream = uint;
enum : uint
{
	aiDefaultLogStream_FILE = 1,
	aiDefaultLogStream_STDOUT = 2,
	aiDefaultLogStream_STDERR = 4,
	aiDefaultLogStream_DEBUGGER = 8,
}
struct aiMemoryInfo
{
	uint textures;
	uint materials;
	uint meshes;
	uint nodes;
	uint animations;
	uint cameras;
	uint lights;
	uint total;
}
enum 
{
	ASSIMP_CFLAGS_SHARED = 1,
	ASSIMP_CFLAGS_STLPORT = 2,
	ASSIMP_CFLAGS_DEBUG = 4,
	ASSIMP_CFLAGS_NOBOOST = 8,
	ASSIMP_CFLAGS_SINGLETHREADED = 16,
}
